import { PrometheusMessageMetric } from "../../PrometheusMessageMetric.js";
export class PrometheusMessageErrorCounter extends PrometheusMessageMetric {
    createMetric(client, metricParams) {
        return new client.Counter({
            name: metricParams.name,
            help: metricParams.helpDescription,
            labelNames: ['queue', 'messageType', 'version', 'errorReason'],
        });
    }
    registerProcessedMessage(metadata) {
        if (metadata.processingResult.status !== 'error')
            return;
        this.metric.inc({
            queue: metadata.queueName,
            messageType: metadata.messageType,
            errorReason: metadata.processingResult.errorReason,
            version: this.messageVersionGeneratingFunction(metadata),
        }, 1);
    }
}
//# sourceMappingURL=PrometheusMessageErrorCounter.js.map